$! make gd under OpenVMS
$!
$! External libraries (like Freetype, XPM, etc.) are supported via the
$! config file VMSLIB.DAT. Please check the sample file, which is part of this
$! distribution, for the information you need to provide
$!
$! In case of problems with the install you might contact me at
$! zinser@decus.de(preferred) or zinser@sysdev.deutsche-boerse.com (work)
$!
$ true  = 1
$ false = 0
$ tmpnam = "temp_" + f$getjpi("","pid")
$ tt = tmpnam + ".txt"
$ tc = tmpnam + ".c"
$!
$! Setup variables holding "config" information
$!
$ Make    = ""
$ ccopt = ""
$ libdefs = ""
$ libincs = ""
$ aconf_in_file = "config.hin"
$ conf_check_string = "#PACKAGE#PACKAGE_NAME#PACKAGE_STRING#VERSION#PACKAGE_BUGREPORT#"
$ x11_save      = ""
$!
$! Check for MMK/MMS
$!
$ If F$Search ("Sys$System:MMS.EXE") .nes. "" Then Make = "MMS"
$ If F$Type (MMK) .eqs. "STRING" Then Make = "MMK"
$!
$ gosub check_compiler
$!
$ gosub check_opts
$!
$ gosub check_version
$!
$ open/write optf gd.opt
$ open/write topt tmp.opt
$ gosub check_create_vmslib
$!
$ incs = "[]" + libincs 
$ gosub set_env
$!
$ defs = f$extract(0,f$length(libdefs)-1,libdefs)
$ ccconf = ccopt +  "/define=(''defs')"
$ close topt
$!
$! Configuration file might be mapped in different ways, so go figure
$!
$ i = 0
$FIND_ACONF:
$ fname = f$element(i,"#",aconf_in_file)
$ if fname .eqs. "#" then goto AMISS_ERR
$ if f$search(fname) .eqs. ""
$ then 
$   i = i + 1
$   goto find_aconf
$ endif
$ open/read/err=aconf_err aconf_in 'fname'
$ open/write aconf config.h
$ACONF_LOOP:
$ read/end_of_file=aconf_exit aconf_in line
$ work = f$edit(line, "compress,trim")
$ if ((f$extract(0,6,work) .nes. "#undef") .and. - 
      (f$extract(0,7,work) .nes. "#define"))
$ then
$   write aconf line
$ else
$   cdef = f$element(1," ",work)
$   gosub check_config
$ endif
$ goto aconf_loop
$ACONF_EXIT:
$ close aconf_in
$ close aconf
$ close optf
$!
$ defs = "HAVE_CONFIG_H," + f$extract(0,f$length(libdefs),libdefs) - ","
$ ccopt = ccopt +  "/define=(''defs')"
$!
$! Build the thing plain or with mms/mmk
$!
$ write sys$output "Compiling GD sources ..."
$ if f$search("libgd.olb").eqs."" then lib/create/object libgd.olb
$ if (Make.eqs."")
$  then
$   call make gd.obj "cc ''ccopt' GD" -
                gd.c
$   lib/replace libgd.olb gd.obj
$   call make gd_gd.obj "cc ''ccopt' gd_gd" -
                gd_gd.c
$   lib/replace libgd.olb gd_gd.obj
$   call make gd_gd2.obj "cc ''ccopt' gd_gd2" -
                gd_gd2.c
$   lib/replace libgd.olb gd_gd2.obj
$   call make gd_io.obj "cc ''ccopt' gd_io" -
                gd_io.c
$   lib/replace libgd.olb gd_io.obj
$   call make gd_io_dp.obj "cc ''ccopt' gd_io_dp" -
                gd_io_dp.c
$   lib/replace libgd.olb gd_io_dp.obj
$   call make gd_io_file.obj "cc ''ccopt' gd_io_file" -
                gd_io_file.c
$   lib/replace libgd.olb gd_io_file.obj
$   call make gd_ss.obj "cc ''ccopt' gd_ss" -
                gd_ss.c
$   lib/replace libgd.olb gd_ss.obj
$   call make gd_io_ss.obj "cc ''ccopt' gd_io_ss" -
                gd_io_ss.c
$   lib/replace libgd.olb gd_io_ss.obj
$   call make gd_png.obj "cc ''ccopt' gd_png" -
                gd_png.c
$   lib/replace libgd.olb gd_png.obj
$   call make gd_jpeg.obj "cc ''ccopt' gd_jpeg" -
                gd_jpeg.c
$   lib/replace libgd.olb gd_jpeg.obj
$   call make gdxpm.obj "cc ''ccopt' gdxpm" -
                gdxpm.c
$   lib/replace libgd.olb gdxpm.obj
$   call make gdfontt.obj "cc ''ccopt' gdfontt" -
                gdfontt.c
$   lib/replace libgd.olb gdfontt.obj
$   call make gdfonts.obj "cc ''ccopt' gdfonts" -
                gdfonts.c
$   lib/replace libgd.olb gdfonts.obj
$   call make gdfontmb.obj "cc ''ccopt' gdfontmb" -
                gdfontmb.c
$   lib/replace libgd.olb gdfontmb.obj
$   call make gdfontl.obj "cc ''ccopt' gdfontl" -
                gdfontl.c
$   lib/replace libgd.olb gdfontl.obj
$   call make gdfontg.obj "cc ''ccopt' gdfontg" -
                gdfontg.c
$   lib/replace libgd.olb gdfontg.obj
$   call make gdtables.obj "cc ''ccopt' gdtables" -
                gdtables.c
$   lib/replace libgd.olb gdtables.obj
$   call make gdft.obj "cc ''ccopt' gdft" -
                gdft.c
$   lib/replace libgd.olb gdttf.obj
$   call make gdcache.obj "cc ''ccopt' gdcache" -
                gdcache.c
$   lib/replace libgd.olb gdcache.obj
$   call make gdkanji.obj "cc ''ccopt' gdkanji" -
                gdkanji.c
$   lib/replace libgd.olb gdkanji.obj
$   call make wbmp.obj "cc ''ccopt' wbmp" -
                wbmp.c
$   lib/replace libgd.olb wbmp.obj
$   call make gd_wbmp.obj "cc ''ccopt' gd_wbmp" -
                gd_wbmp.c
$   lib/replace libgd.olb gd_wbmp.obj
$   call make gdhelpers.obj "cc ''ccopt' gdhelpers" -
                gdhelpers.c
$   lib/replace libgd.olb gdhelpers.obj
$   call make gd_topal.obj "cc ''ccopt' gd_topal" -
                gd_topal.c
$   lib/replace libgd.olb gd_topal.obj
$   call make pngtogd.obj "cc ''ccopt' pngtogd" -
                pngtogd.c
$   call make pngtogd2.obj "cc ''ccopt' pngtogd2" -
                pngtogd2.c
$   call make gdtopng.obj "cc ''ccopt' gdtopng" -
                gdtopng.c
$   call make gd2topng.obj "cc ''ccopt' gd2topng" -
                gd2topng.c
$   call make gd2copypal.obj "cc ''ccopt' gd2copypal" -
                gd2copypal.c
$   call make gdparttopng.obj "cc ''ccopt' gdparttopng" -
                gdparttopng.c
$   call make webpng.obj "cc ''ccopt' webpng" -
                webpng.c
$   call make gdtest.obj "cc ''ccopt' gdtest" -
                gdtest.c
$   call make gddemo.obj "cc ''ccopt' gddemo" -
                gddemo.c
$   call make gd2time.obj "cc ''ccopt' gd2time" -
                gd2time.c
$   call make gdtestttf.obj "cc ''ccopt' gdtestft" -
                gdtestft.c
$   call make testac.obj "cc ''ccopt' testac" -
                testac.c
$   call make gd2copypal.exe "link gd2copypal,libgd.olb/lib,gd.opt/opt" -
         gd2copypal.obj libgd.olb
$   call make gd2time.exe "link gd2time,libgd.olb/lib,gd.opt/opt" - 
         gd2time.obj libgd.olb
$   call make gd2topng.exe "link gd2topng,libgd.olb/lib,gd.opt/opt" -
         gd2topng.obj libgd.olb
$   call make gddemo.exe "link gddemo,libgd.olb/lib,gd.opt/opt" -
         gddemo.obj libgd.olb
$   call make gdtest.exe "link gdtest,libgd.olb/lib,gd.opt/opt" -
         gdtest.obj libgd.olb
$   call make gdtopng.exe "link gdtopng,libgd.olb/lib,gd.opt/opt" -
         gdtopng.obj libgd.olb
$   call make pngtogd.exe "link pngtogd,libgd.olb/lib,gd.opt/opt" -
         pngtogd.obj libgd.olb
$   call make pngtogd2.exe "link pngtogd2,libgd.olb/lib,gd.opt/opt" -
         pngtogd2.obj libgd.olb
$   call make webpng.exe "link webpng,libgd.olb/lib,gd.opt/opt" -
         webpng.obj libgd.olb
$   call make testac.exe "link testac,libgd.olb/lib,gd.opt/opt" -
         testac.obj libgd.olb
$   call make gdtestft.exe "link gdtestft,libgd.olb/lib,gd.opt/opt" -
         gdtestft.obj libgd.olb
$  else
$   gosub crea_mms
$   'Make' /macro="ccopt=''ccopt'"
$ endif
$ write sys$output "GD build completed"
$ gosub RESET_ENV
$ exit
$ACONF_ERR:
$ write sys$output "Input file ''fname' could not be opened"
$ goto err_exit
$AMISS_ERR:
$ write sys$output "No source for config.hin found."
$ write sys$output "Tried any of ''aconf_in_file'"
$CC_ERR:
$ write sys$output "C compiler required to build GDlib"
$ goto err_exit
$ERR_LIB:
$ write sys$output "Can not open config file vmslib.dat"
$ goto err_exit
$FT2_ERR:
$ write sys$output "Can not find [.internal] sub-dir in Freetype 2 tree"
$ goto err_exit
$ERR_EXIT:
$ set message/facil/ident/sever/text
$ gosub reset_env
$ close/nolog optf
$ close/nolog aconf_in
$ close/nolog aconf
$ close/nolog tmpc
$ write sys$output "Exiting..."
$ exit 2
$!
$MAKE: SUBROUTINE   !SUBROUTINE TO CHECK DEPENDENCIES
$ V = 'F$Verify(0)
$! P1 = What we are trying to make
$! P2 = Command to make it
$! P3 - P8  What it depends on
$
$ If F$Search(P1) .Eqs. "" Then Goto Makeit
$ Time = F$CvTime(F$File(P1,"RDT"))
$arg=3
$Loop:
$       Argument = P'arg
$       If Argument .Eqs. "" Then Goto Exit
$       El=0
$Loop2:
$       File = F$Element(El," ",Argument)
$       If File .Eqs. " " Then Goto Endl
$       AFile = ""
$Loop3:
$       OFile = AFile
$       AFile = F$Search(File)
$       If AFile .Eqs. "" .Or. AFile .Eqs. OFile Then Goto NextEl
$       If F$CvTime(F$File(AFile,"RDT")) .Ges. Time Then Goto Makeit
$       Goto Loop3
$NextEL:
$       El = El + 1
$       Goto Loop2
$EndL:
$ arg=arg+1
$ If arg .Le. 8 Then Goto Loop
$ Goto Exit
$
$Makeit:
$ VV=F$VERIFY(0)
$ write sys$output P2
$ 'P2
$ VV='F$Verify(VV)
$Exit:
$ If V Then Set Verify
$ENDSUBROUTINE
$!
$!------------------------------------------------------------------------------
$EVAL_LOGI: SUBROUTINE
$ lnam = p1
$ lval = ""
$ i = 0
$LLOOP:
$ ltrans = f$trnlnm(lnam,,i)
$ if ltrans .nes. ""
$ then
$   i = i + 1
$   lval = lval + "," + ltrans
$   goto lloop
$ endif
$ lval = lval - "," 
$ lval :== "''lval'" 
$ENDSUBROUTINE
$!------------------------------------------------------------------------------
$!
$! Take care of driver file with information about external libraries
$!
$CHECK_CREATE_VMSLIB:
$!
$ if f$search("VMSLIB.DAT") .eqs. ""
$ then
$   type/out=vmslib.dat sys$input
!
! This is a simple driver file with information used by vms_make.com to
! check if external libraries (like t1lib and freetype) are available on
! the system.
!
! Layout of the file:
!
!    - Lines starting with ! are treated as comments
!    - Elements in a data line are separated by # signs
!    - The elements need to be listed in the following order
!      1.) Name of the Library (only used for informative messages
!                               from vms_make.com)
!      2.) Location where the object library can be found
!      3.) Location where the include files for the library can be found
!      4.) Include file used to verify library location
!      5.) CPP define to pass to the build to indicate availability of
!          the library
!
! Example: The following  lines show how definitions
!          might look like. They are site specific and the locations of the
!          library and include files need almost certainly to be changed.
!
! Location: All of the libaries can be found at the following addresses
!
!   LIBPNG:     http://www.decus.de:8080/www/vms/sw/libpng.htmlx
!   ZLIB:       http://www.decus.de:8080/www/vms/sw/zlib.htmlx
!   JPEG:       http://www.decus.de:8080/www/vms/sw/jpeg.htmlx
!   FREETYPE:   http://www.decus.de:8080/www/vms/sw/freetype2.htmlx
!   XPM:        http://www.decus.de:8080/www/vms/sw/xpm.htmlx
!
!PNG      # pubbin:libpng.olb   # public$root:[util.libs.libpng]            # png.h      # HAVE_LIBPNG
!ZLIB     # pubbin:libz.olb     # public$root:[util.libs.zlib]              # zlib.h     #
!JPEG     # pubbin:jpegshr.exe  # public$root:[util.libs.jpeg]              # jpeglib.h  # HAVE_LIBJPEG
!FREETYPE # pubbin:freetype.olb # public$root:[xtools.libs.ft2.include.freetype],public$root:[xtools.libs.ft2.include] # freetype.h # HAVE_LIBFREETYPE
!XPM      # pubbin:libxpm.olb   # X11:                                      # xpm.h      # HAVE_XPM
$   write sys$output "New driver file vmslib.dat created."
$   write sys$output "Please customize libary locations for your site"
$   write sys$output "and afterwards re-execute vms_make.com"
$   write sys$output "Exiting..."
$   close/nolog optf
$   exit
$ endif
$!
$! Open data file with location of libraries
$!
$ open/read/end=end_lib/err=err_lib libdata VMSLIB.DAT
$LIB_LOOP:
$ read/end=end_lib libdata libline
$ libline = f$edit(libline, "UNCOMMENT,COLLAPSE")
$ if libline .eqs. "" then goto LIB_LOOP ! Comment line
$ libname = f$edit(f$element(0,"#",libline),"UPCASE")
$ write sys$output "Processing ''libname' setup ..."
$ libloc  = f$element(1,"#",libline)
$ libsrc  = f$element(2,"#",libline)
$ testinc = f$element(3,"#",libline)
$ cppdef  = f$element(4,"#",libline)
$ old_cpp = f$locate("=1",cppdef)
$ if old_cpp.lt.f$length(cppdef) then cppdef = f$extract(0,old_cpp,cppdef)
$ if f$search("''libloc'").eqs. ""
$ then
$   write sys$output "Can not find library ''libloc' - Skipping ''libname'"
$   goto LIB_LOOP
$ endif
$ libsrc_elem = 0
$ libsrc_found = false
$LIBSRC_LOOP:
$ libsrcdir = f$element(libsrc_elem,",",libsrc)
$ if (libsrcdir .eqs. ",") then goto END_LIBSRC
$ if f$search("''libsrcdir'''testinc'") .nes. "" then libsrc_found = true
$ libsrc_elem = libsrc_elem + 1
$ goto LIBSRC_LOOP
$END_LIBSRC:
$ if .not. libsrc_found
$ then
$   write sys$output "Can not find includes at ''libsrc' - Skipping ''libname'"
$   goto LIB_LOOP
$ endif
$ if cppdef .nes. "" then libdefs = libdefs +  cppdef + ","
$ libincs = libincs + "," + libsrc
$ lqual = "/lib"
$ libtype = f$edit(f$parse(libloc,,,"TYPE"),"UPCASE")
$ if f$locate("EXE",libtype) .lt. f$length(libtype) then lqual = "/share"
$ write optf libloc , lqual
$ write topt libloc , lqual
$!
$! Nasty hack to get the freetype includes to work
$!
$ if ((libname .eqs. "FREETYPE") .and. -
      (f$locate("FREETYPE",cppdef) .lt. f$length(cppdef)))
$ then
$   if ((f$search("freetype:freetype.h") .nes. "") .and. -
        (f$search("freetype:[internal]ftobjs.h") .nes. ""))
$   then
$     write sys$output "Will use local definition of freetype logical"
$     ft2def = 0
$   else
$     ft2elem = 0
$FT2_LOOP:
$     ft2srcdir = f$element(ft2elem,",",libsrc)
$     if f$search("''ft2srcdir'''testinc'") .nes. ""
$     then
$        if f$search("''ft2srcdir'internal.dir") .nes. ""
$        then
$          ft2dev  = f$parse("''ft2srcdir'",,,"device","no_conceal")
$          ft2dir  = f$parse("''ft2srcdir'",,,"directory","no_conceal")
$          ft2conc = f$locate("][",ft2dir)
$          ft2len  = f$length(ft2dir)
$          if ft2conc .lt. ft2len
$          then
$             ft2dir = f$extract(0,ft2conc,ft2dir) + -
                       f$extract(ft2conc+2,ft2len-2,ft2dir)
$          endif
$          ft2dir = ft2dir - "]" + ".]"
$          define freetype 'ft2dev''ft2dir','ft2srcdir'
$          ft2def = 1
$        else
$          goto ft2_err
$        endif
$     else
$       ft2elem = ft2elem + 1
$       goto ft2_loop
$     endif
$   endif
$ endif
$!
$! Yet another special treatment for Xpm/X11
$!
$ if (libname .eqs. "XPM")
$ then
$   my_x11 = f$parse("''libsrc'xpm.h",,,"device") + - 
             f$parse("''libsrc'xpm.h",,,"directory")
$   x11_save = f$trnlnm("X11")
$   define x11 'my_x11',decw$include   
$ endif 
$ goto LIB_LOOP
$END_LIB:
$ close libdata
$ return
$!------------------------------------------------------------------------------
$RESET_ENV:
$ if (ft2def) then deassign freetype
$ if its_decc
$ then
$  if cc_user .eqs. ""
$  then
$    deass decc$user_include
$  else
$    define decc$user_include 'cc_user'
$  endif
$  if cc_system .eqs. ""
$  then
$    deass decc$system_include
$  else
$    define decc$system_include 'cc_system'
$  endif
$ endif
$ if (x11_save .nes. "") then define x11 'x11_save'
$ return
$!------------------------------------------------------------------------------
$!
$! Look for the compiler used 
$!
$CHECK_COMPILER:
$ its_decc = (f$search("SYS$SYSTEM:DECC$COMPILER.EXE") .nes. "")
$ its_vaxc = .not. its_decc .and. (F$Search("SYS$System:VAXC.Exe") .nes. "")
$ its_gnuc = .not. (its_decc .or. its_vaxc) .and. (f$trnlnm("gnu_cc") .nes. "")
$!
$! Exit if no compiler available
$!
$ if (.not. (its_decc .or. its_vaxc .or. its_gnuc)) then goto CC_ERR
$ return
$!------------------------------------------------------------------------------
$!
$! Set logicals as required
$!
$!
$SET_ENV:
$ ccopt = "/nolist"
$ if its_decc
$ then
$   ccopt = ccopt + "/prefix=all"
$   if f$getsyi("HW_MODEL") .lt. 1024 then ccopt = "/DECC" + ccopt
$!
$! Take care of includes
$!
$   call eval_logi "DECC$USER_INCLUDE"
$   cc_user = lval
$   call eval_logi "DECC$SYSTEM_INCLUDE"
$   cc_system = lval
$   define decc$system_include  'incs'
$   define decc$user_include    'incs'
$ endif
$!
$ if its_gnuc
$ then
$   ccopt = ccopt + "/nocase"
$   write optf "gnu_cc:[000000]gcclib.olb/lib"
$   write optf "sys$share:vaxcrtl.exe/share"
$ endif
$ return
$!------------------------------------------------------------------------------
$!
$! Check command line options and set symbols accordingly
$!
$ CHECK_OPTS:
$ i = 1
$ OPT_LOOP:
$ if i .lt. 9
$ then
$   cparm = f$edit(p'i',"upcase")
$   if cparm .eqs. "DEBUG"
$   then
$     ccopt = ccopt + "/noopt/deb"
$     lopts = lopts + "/deb"
$   endif
$   if f$locate("CCOPT",cparm) .lt. f$length(cparm)
$   then
$     start = f$locate("=",cparm) + 1
$     len   = f$length(cparm) - start
$     ccopt = ccopt + f$extract(start,len,cparm)
$   endif
$   if cparm .eqs. "LINK" then linkonly = true
$   if f$locate("LOPTS",cparm) .lt. f$length(cparm) 
$   then
$     start = f$locate("=",cparm) + 1
$     len   = f$length(cparm) - start
$     lopts = lopts + f$extract(start,len,cparm)
$   endif
$   if f$locate("CC",cparm) .lt. f$length(cparm)
$   then
$     start = f$locate("=",cparm) + 1
$     len   = f$length(cparm) - start
$     comp  = comp + f$extract(start,len,cparm)
$     if (comp .eqs. "DECC") .or. (comp .eqs. "GNUC") .or. (comp .eqs. "VAXC")
$     then
$       its_decc = false
$       its_vaxc = false
$       its_gnuc = false 
$       its_'comp' = true
$     else
$       write sys$output "Comp must be one of DECC, GNUC, or VAXC"
$       write sys$output "Value ''comp' ignored"
$     endif 
$   endif
$   i = i + 1
$   goto opt_loop
$ endif
$ return
$!------------------------------------------------------------------------------
$!
$! Take care of driver file with information about external libraries
$!
$CHECK_CONFIG:
$!
$ in_ldef = f$locate(cdef,libdefs)
$ if (in_ldef .lt. f$length(libdefs))
$ then
$   write aconf "#define ''cdef' 1"
$   libdefs = f$extract(0,in_ldef,libdefs) + -
              f$extract(in_ldef + f$length(cdef) + 1, -
	                f$length(libdefs) - in_ldef - f$length(cdef) - 1, -
			libdefs) 
$ else
$   if (f$type('cdef') .nes. "")
$   then
$     write aconf "#define ''cdef' ", 'cdef'
$   else 
$     gosub check_cc_def
$   endif
$ endif
$ return
$!------------------------------------------------------------------------------
$!
$! Check if this is a define relating to the properties of the C/C++
$! compiler
$!
$CHECK_CC_DEF:
$ if (cdef .eqs. "HAVE_DLFCN_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <dlfcn.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_ERRNO_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <errno.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_ICONV")
$ then
$   copy sys$input: 'tc
$   deck
#include <iconv.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_ICONV_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <iconv.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_ICONV_T_DEF")
$ then
$   copy sys$input: 'tc
$   deck
#include <iconv.h>
int main(){
iconv_t dummy;
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_INTTYPES_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <inttypes.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_LIMITS_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <limits.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_MEMORY_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <memory.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_STDDEF_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <stddef.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_STDINT_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <stdint.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_STDLIB_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <stdlib.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_STRINGS_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <strings.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_STRING_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <string.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_SYS_STAT_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <sys/stat.h>

int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_SYS_TYPES_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <sys/types.h>

int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "HAVE_UNISTD_H")
$ then
$   copy sys$input: 'tc
$   deck
#include <unistd.h>

int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ if (cdef .eqs. "STDC_HEADERS")
$ then
$   copy sys$input: 'tc
$   deck
#include <stdlib.h>
#include <stddef.h>
int main(){
}
$   eod
$   gosub cc_prop_check
$   return
$ endif
$ write aconf "/* ", line, " */" 
$ return
$!
$!------------------------------------------------------------------------------
$!
$! Check for properties of C/C++ compiler
$!
$CC_PROP_CHECK:
$ cc_prop = true
$ set message/nofac/noident/nosever/notext
$ on error then continue
$ cc 'tmpnam'
$ if .not. ($status)  then cc_prop = false
$ on error then continue
$! The headers might lie about the capabilities of the RTL
$ link 'tmpnam',tmp.opt/opt
$ if .not. ($status)  then cc_prop = false
$ set message/fac/ident/sever/text
$ on error then goto err_exit
$ delete/nolog 'tmpnam'.*;*
$ if cc_prop
$ then
$   write sys$output "Checking for ''cdef'... yes"
$   write aconf "#define ''cdef' 1"
$   if (cdef .eqs. "HAVE_FSEEKO") .or. (cdef .eqs. "_LARGE_FILES") then -
      write aconf "#define _LARGEFILE"
$ else
$   write sys$output "Checking for ''cdef'... no"
$   write aconf line
$ endif
$ return
$
$!------------------------------------------------------------------------------
$!
$! Check version of program to build
$!
$! To be checked properties defined as in e.g.
$! conf_check_string = "#PACKAGE#VERSION#"
$!
$CHECK_VERSION:
$ open/read in configure.;
$vloop:
$ read/end=vdone in rec
$ var = f$edit(f$element(0,"=",rec),"TRIM")
$ probe = "#" + var + "#"
$ if f$locate(probe,conf_check_string) .lt. f$length(conf_check_string)
$ then
$  val = f$element(1,"=",rec)
$  if (f$extract(0,1,val) .eqs. "'") .and. -
      (f$extract(f$length(val)-1,1,val) .eqs. "'") then - 
      val = f$extract(1,f$length(val)-2,val)
$  'var' = """" + val  + """"
$ endif
$ goto vloop
$vdone:
$ close in
$ return
$!------------------------------------------------------------------------------
$!
$! If MMS/MMK are available dump out the descrip.mms if required
$!
$CREA_MMS:
$ write sys$output "Creating descrip.mms..."
$ create descrip.mms
$ open/append out descrip.mms
$ copy sys$input: out
$ deck
#In case of problems with the install you might contact me at
#zinser@decus.de (preferred) or zinser@sysdev.deutsche-boerse.com

CCOPT =
CC=cc 
CFLAGS= $(CCOPT)

all : libgd.olb gd2copypal.exe gd2time.exe gd2topng.exe gddemo.exe gdtest.exe \
      gdtopng.exe pngtogd.exe pngtogd2.exe webpng.exe testac.exe \
      gdparttopng.exe gdtestft.exe annotate.exe fontwheeltest.exe \
      fontsizetest.exe

OBJS = gd.obj, gd_gd.obj, gd_gd2.obj, gd_io.obj, gd_io_dp.obj, gd_io_file.obj, \
        gd_ss.obj, gd_io_ss.obj, gd_png.obj, gd_jpeg.obj, gdxpm.obj, \
	gdfontt.obj, gdfonts.obj, gdfontmb.obj, gdfontl.obj, gdfontg.obj, \
	gdtables.obj, gdft.obj, gdcache.obj, gdkanji.obj,  wbmp.obj, \
	gd_wbmp.obj, gdhelpers.obj, gd_topal.obj

libgd.olb : libgd.olb($(OBJS))
       @ write sys$output " Libgd available "
       
gddemo.exe : gddemo.obj libgd.olb 
	$ link gddemo.obj,libgd.olb/lib,gd.opt/opt

testac.exe : testac.obj libgd.olb
        $ link testac.obj,libgd.olb/lib,gd.opt/opt
pngtogd.exe : pngtogd.obj libgd.olb 
	$link pngtogd.obj,libgd.olb/lib,gd.opt/opt

webpng.exe : webpng.obj libgd.olb 
	$link webpng.obj,libgd.olb/lib,gd.opt/opt

pngtogd2.exe : pngtogd2.obj libgd.olb 
	$link pngtogd2.obj,libgd.olb/lib,gd.opt/opt

gdtopng.exe : gdtopng.obj libgd.olb 
	$link gdtopng.obj,libgd.olb/lib,gd.opt/opt

gd2topng.exe : gd2topng.obj libgd.olb 
	$link gd2topng.obj,libgd.olb/lib,gd.opt/opt

gd2copypal.exe : gd2copypal.obj libgd.olb 
	$link gd2copypal.obj,libgd.olb/lib,gd.opt/opt

gdparttopng.exe : gdparttopng.obj libgd.olb 
	$link gdparttopng.obj,libgd.olb/lib,gd.opt/opt

gdtest.exe : gdtest.obj libgd.olb 
	$link gdtest.obj,libgd.olb/lib,gd.opt/opt

gd2time.exe : gd2time.obj libgd.olb 
	$link gd2time.obj,libgd.olb/lib,gd.opt/opt

gdtestft.exe : gdtestft.obj libgd.olb
        $link gdtestft.obj,libgd.olb/lib,gd.opt/opt

annotate.exe : annotate.obj libgd.olb
        $link annotate.obj,libgd.olb/lib,gd.opt/opt

fontwheeltest.exe : fontwheeltest.obj libgd.olb
        $link fontwheeltest.obj,libgd.olb/lib,gd.opt/opt

fontsizetest.exe : fontsizetest.obj libgd.olb
        $link fontsizetest.obj,libgd.olb/lib,gd.opt/opt
	 
clean :
        purge
	delete *.obj. 

...
$ eod
$ close out
$ return
$!------------------------------------------------------------------------------
